GNU bug report logs - #21997
epa--key-widget-value-create ignores signing subkeys

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: John Wiegley <jwiegley@HIDDEN>; Keywords: moreinfo; Done: Lars Ingebrigtsen <larsi@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
bug closed, send any further explanations to 21997 <at> debbugs.gnu.org and John Wiegley <jwiegley@HIDDEN> Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 21997 <at> debbugs.gnu.org:


Received: (at 21997) by debbugs.gnu.org; 9 Jun 2022 15:02:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 09 11:02:55 2022
Received: from localhost ([127.0.0.1]:47316 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nzJgV-0006VL-7z
	for submit <at> debbugs.gnu.org; Thu, 09 Jun 2022 11:02:55 -0400
Received: from quimby.gnus.org ([95.216.78.240]:51024)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1nzJgS-0006V4-Vw
 for 21997 <at> debbugs.gnu.org; Thu, 09 Jun 2022 11:02:53 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:To:From:Sender:Reply-To:Cc:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=wC18MkYOVSf86mA9xp5uDmaI0UuG4vndUq0/P5oraUQ=; b=jLfrEHZU92xycBOmDEjtKpavpK
 seOPCwhnjMlDFQqXN6hp24iTVJP1yrVmCI2jNonRGU1eg6yczddlns5WDk25RRUs0vE0GE/m2JCYV
 5LLwXpLVuJDadEApRa35MUl9vzFE6tKlTl+W1kgrC58sTj5bxMorbn5Kne25aHPeioxs=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>) id 1nzJgK-0001P9-W2
 for 21997 <at> debbugs.gnu.org; Thu, 09 Jun 2022 17:02:47 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: 21997 <at> debbugs.gnu.org
Subject: Re: bug#21997: epa--key-widget-value-create ignores signing subkeys
References: <m2io4shaz7.fsf@HIDDEN> <87tu9vx76w.fsf@HIDDEN>
X-Now-Playing: Farben's _textstar+_: "FF (Remaster 2022)"
Date: Thu, 09 Jun 2022 17:02:44 +0200
In-Reply-To: <87tu9vx76w.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Thu,
 12 May 2022 14:32:23 +0200")
Message-ID: <87pmjh282z.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Lars Ingebrigtsen <larsi@HIDDEN> writes: > I think I
 vaguely
 remember something like this being fixed over the last > couple of years
 (and the `epa--key-widget-value-create' function no > longer exists). Do you
 still see this problem in rece [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 21997
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> I think I vaguely remember something like this being fixed over the last
> couple of years (and the `epa--key-widget-value-create' function no
> longer exists).  Do you still see this problem in recent Emacs versions?

More information was requested, but no response was given within a
month, so I'm closing this bug report.  If the problem still exists,
please respond to this email and we'll reopen the bug report.

-- 
(domestic pets only, the antidote for overdose, milk.)  bloggy blog:
   http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21997; Package emacs. Full text available.
Added tag(s) moreinfo. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 12 May 2022 12:32:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 12 08:32:32 2022
Received: from localhost ([127.0.0.1]:39938 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1np7zb-0004ZN-Lw
	for submit <at> debbugs.gnu.org; Thu, 12 May 2022 08:32:32 -0400
Received: from lists.gnu.org ([209.51.188.17]:42614)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1np7za-0004YS-At
 for submit <at> debbugs.gnu.org; Thu, 12 May 2022 08:32:30 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:48636)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <larsi@HIDDEN>) id 1np7za-0003E9-0f
 for bug-gnu-emacs@HIDDEN; Thu, 12 May 2022 08:32:30 -0400
Received: from quimby.gnus.org ([2a01:4f9:2b:f0f::2]:42510)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <larsi@HIDDEN>) id 1np7zY-0005M4-Da
 for bug-gnu-emacs@HIDDEN; Thu, 12 May 2022 08:32:29 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:To:From:Sender:Reply-To:Cc:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=HSQ+p4e4/QwLgPDPwJm5rPbpGROh8KSnhDwcz6e6EU4=; b=epbmXoDmCY+917r+nMmL6NqME7
 Tjam+UlHEU+Cp3hUrEaShR/8HOkK7m/lXmCLxyqbAEQKCWPqOO/0ZEZ86FkBmVI/tD2W673CEjZih
 eIOx4UFtzrvUnBQnNsqM1wSY6RVX0A5EfMwx62z94DceT40FQthpAvwOi9takUGYnEOc=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>) id 1np7zT-0004dv-So
 for bug-gnu-emacs@HIDDEN; Thu, 12 May 2022 14:32:26 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: Re: bug#21997: epa--key-widget-value-create ignores signing subkeys
References: <m2io4shaz7.fsf@HIDDEN>
X-Now-Playing: Front 242's _Geography_: "He Runs Too Fast For Us"
Date: Thu, 12 May 2022 14:32:23 +0200
In-Reply-To: <m2io4shaz7.fsf@HIDDEN> (John Wiegley's message of "Mon, 
 23 Nov 2015 09:38:52 -0800")
Message-ID: <87tu9vx76w.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: John Wiegley <jwiegley@HIDDEN> writes: > When listing
 secret
 keys using `M-x epa-list-secret-keys', one can press RET > on the inserted
 widget to see a list of associated subkeys. This shows that > epa.el is
 correctly parsing the subkeys o [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
Received-SPF: pass client-ip=2a01:4f9:2b:f0f::2; envelope-from=larsi@HIDDEN;
 helo=quimby.gnus.org
X-Spam_score_int: -43
X-Spam_score: -4.4
X-Spam_bar: ----
X-Spam_report: (-4.4 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 RCVD_IN_DNSWL_MED=-2.3, SPF_HELO_NONE=0.001, SPF_PASS=-0.001,
 T_SCC_BODY_TEXT_LINE=-0.01 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

John Wiegley <jwiegley@HIDDEN> writes:

> When listing secret keys using `M-x epa-list-secret-keys', one can press RET
> on the inserted widget to see a list of associated subkeys. This shows that
> epa.el is correctly parsing the subkeys of one's secret key.
>
> However, the :value of that widget always chooses the first subkey, as seen
> here:
>
>     (defun epa--key-widget-value-create (widget)
>       (let* ((key (widget-get widget :value))
> -->          (primary-sub-key (car (epg-key-sub-key-list key)))
>              (primary-user-id (car (epg-key-user-id-list key))))
>         ...))

(I'm going through old bug reports that unfortunately weren't resolved
at the time.)

I think I vaguely remember something like this being fixed over the last
couple of years (and the `epa--key-widget-value-create' function no
longer exists).  Do you still see this problem in recent Emacs versions?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21997; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 23 Nov 2015 17:39:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 23 12:39:22 2015
Received: from localhost ([127.0.0.1]:49785 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1a0v5G-0006dD-Gh
	for submit <at> debbugs.gnu.org; Mon, 23 Nov 2015 12:39:22 -0500
Received: from eggs.gnu.org ([208.118.235.92]:39426)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <jwiegley@HIDDEN>) id 1a0v4x-0006cc-0F
 for submit <at> debbugs.gnu.org; Mon, 23 Nov 2015 12:39:21 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <jwiegley@HIDDEN>) id 1a0v4v-0007fK-OS
 for submit <at> debbugs.gnu.org; Mon, 23 Nov 2015 12:39:02 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:42274)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <jwiegley@HIDDEN>) id 1a0v4v-0007fG-MC
 for submit <at> debbugs.gnu.org; Mon, 23 Nov 2015 12:39:01 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:49428)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <jwiegley@HIDDEN>) id 1a0v4u-0002a8-CZ
 for bug-gnu-emacs@HIDDEN; Mon, 23 Nov 2015 12:39:01 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <jwiegley@HIDDEN>) id 1a0v4r-0007ev-14
 for bug-gnu-emacs@HIDDEN; Mon, 23 Nov 2015 12:39:00 -0500
Received: from mail-pa0-x22f.google.com ([2607:f8b0:400e:c03::22f]:35130)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <jwiegley@HIDDEN>) id 1a0v4q-0007er-Rk
 for bug-gnu-emacs@HIDDEN; Mon, 23 Nov 2015 12:38:56 -0500
Received: by pacej9 with SMTP id ej9so197395906pac.2
 for <bug-gnu-emacs@HIDDEN>; Mon, 23 Nov 2015 09:38:56 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=from:to:subject:date:message-id:user-agent:mail-followup-to
 :mime-version:content-type;
 bh=ZeQNj0Iythffv17ea4qqkO5iUa5lr/inlR6r9bN6HVY=;
 b=bopYzBiidebl5p3cidENYVoH/RXi+LrRCpoiFrHRd16P6z9LHuRYWCz/eQd5d6AIA9
 zgNByoK5I8aRq/LOb8vtPz/9raFMal9CiTD7Ylz/uNqyh3WKhEROgjV0WO0KLiI1PEDi
 n7AE7YNvCL6WlJ4Aqf3GD/as0alcedehkqsIn5h3DftqKqxlZVzccPUT2BikZYh6nKCG
 NhojGuM9rbdt52IIedJt2n5uH4GcBEABTCLuzz0wOUYYGUMPOHX/rNXY5fT+mKAZrikD
 TmPkfFrLyhRy61IxEIclbvlGnzw+0Wr04CJEL0pCRBd7LwphRniqSNIi3YW02cgcPZjg
 vC4g==
X-Received: by 10.98.14.75 with SMTP id w72mr17610696pfi.166.1448300336395;
 Mon, 23 Nov 2015 09:38:56 -0800 (PST)
Received: from Vulcan.local (76-234-68-79.lightspeed.frokca.sbcglobal.net.
 [76.234.68.79])
 by smtp.gmail.com with ESMTPSA id vk10sm11171254pbc.66.2015.11.23.09.38.54
 for <bug-gnu-emacs@HIDDEN>
 (version=TLS1 cipher=AES128-SHA bits=128/128);
 Mon, 23 Nov 2015 09:38:54 -0800 (PST)
From: John Wiegley <jwiegley@HIDDEN>
X-Google-Original-From: "John Wiegley" <johnw@HIDDEN>
Received: by Vulcan.local (Postfix, from userid 501)
 id DC55D10ABA86B; Mon, 23 Nov 2015 09:38:53 -0800 (PST)
To: bug-gnu-emacs@HIDDEN
Subject: epa--key-widget-value-create ignores signing subkeys
Date: Mon, 23 Nov 2015 09:38:52 -0800
Message-ID: <m2io4shaz7.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (darwin)
Mail-Followup-To: bug-gnu-emacs@HIDDEN
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

When listing secret keys using `M-x epa-list-secret-keys', one can press RET
on the inserted widget to see a list of associated subkeys. This shows that
epa.el is correctly parsing the subkeys of one's secret key.

However, the :value of that widget always chooses the first subkey, as seen
here:

    (defun epa--key-widget-value-create (widget)
      (let* ((key (widget-get widget :value))
-->          (primary-sub-key (car (epg-key-sub-key-list key)))
             (primary-user-id (car (epg-key-user-id-list key))))
        ...))

For people with multiple subkeys -- especially those who use dedicated subkeys
for signing and/or encrypting -- it would be nice to be able to select which
subkey(s) to use. The only way I can see this fitting into the current EasyPG
selection architecture would be to present each subkey as if it were a
separate, virtual secret key. In other words, where every subkey becomes a
separate widget in the list and selection buffers.

This also affects mml signing in Gnus, since it also uses the widget :value to
determine which key to use for signing.

John




Acknowledgement sent to John Wiegley <jwiegley@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#21997; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Thu, 9 Jun 2022 15:15:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.